## ---------------------------
##
## Script name: Gadget initial parameters
##
## Purpose of script: Build the model and define initial parameters
##
## ---------------------------

## Collate actions
actions <- c(
  time_actions,
  stock_actions,
  # list(
  #   g3l_random_walk(
  #     'growth',
  #     substitute(log(avoid_zero(x)),
  #                list(x = g3_parameterized('ghl.K', by_year = TRUE))),
  #     weight = g3_parameterized('rnd_weight', scale = -1),
  #     sigma_f = g3_parameterized('ghl_K_sigma'))
  # ),
  fleet_actions,
  likelihood_actions)

## Actions to tmb_model

tmb_model <- g3_to_tmb(actions)

# Get the parameter template

tmb_param <- attr(tmb_model, "parameter_template")

# Init sigma hack, delete

# init_sigma <- init_sigma %>%
#   filter(!(stock == "ghl_female_imm" & age >= 3)) %>%
#   bind_rows(init_sigma %>%
#               filter(stock == "ghl_female_mat") %>%
#               mutate(stock = "ghl_female_imm"))
## Set initial population sd to same than recl.sd
# if(!tmb_param[grep('rec.sd', tmb_param$switch),"optimise"]) {
#   init_sigma[init_sigma$age == 1, "ms"] <- unname(unlist(tmb_param[grep('rec.sd', tmb_param$switch),]$value))
# }

## Define the initial parameters

tmb_param <-
  tmb_param %>%
  g3_init_guess('\\.rec', 1e4, 0.1, 2.5e4, 1) %>%
  # g3_init_guess('\\.init', 1e4, 0.1, 1e5, 1) %>%
  g3_init_guess('recl', 14, 12, 20, 0) %>%
  g3_init_guess('rec.sd', 2, 1, 8, 0) %>%
  g3_init_guess('rec.1980', 0, 0, 100, 0) %>%
  # g3_init_guess('rec.2021', 1, 0, 100, 0) %>%
  g3_init_guess('rec.scalar', 1, 1, 100, 0) %>%
  g3_init_guess('init.scalar', 35, 1, 100, 1) %>%
  g3_init_guess('_female.Linf', 100.9, 80, 120, 1) %>%
  g3_init_guess('_male.Linf', 68, 40, 100, 0) %>%
  g3_init_guess('\\.K', 200, 20, 500, 1) %>%
  # g3_init_guess('ghl_K_sigma', 0.2, 0, 1, 0) %>%
  # g3_init_guess('rnd_weight', 1, 1, 100, 0) %>%
  g3_init_guess('bbin', 6, 1e-08, 10, 1) %>%
  g3_init_guess('prop_mat0', 0.1, 0, 1, 1) %>%
  g3_init_guess('B0', 1e5, 1, 1e7, 1) %>%
  g3_init_guess('\\.alpha', 0.5, 0.1, 20, 1) %>%
  g3_init_guess('l50', 40, 5, 80, 1) %>%
  # g3_init_guess('ecos.survey.alpha', 0.5, 0.01, 8, 1) %>%
  g3_init_guess('ecos.survey.l50', 20, 5, 50, 1) %>%
  g3_init_guess('andersen.p0$', 0, NA, NA, 0) %>%
  g3_init_guess('andersen.p2$', 1, NA, NA, 0) %>%
  g3_init_guess('andersen.L$', stock_params$maxlength, NA, NA, 0) %>%
  g3_init_guess('\\.p1$', log(2), 0, 3, 1) %>%
  g3_init_guess('\\.p3$', 0.1, 0, 100, 1) %>%
  g3_init_guess('\\.p4$', 0.02, 0, 1e3, 1) %>%
  g3_init_guess('init.F', 0.4, 0.001, 0.8, 1) %>%
  # g3_init_guess('\\.M', 0.1, 0.001, 1, 0) %>%
  g3_init_guess('_female.M', 0.12, 0.001, 0.4, 0) %>%
  g3_init_guess('_male.M', 0.16, 0.001, 0.4, 0) %>%
  g3_init_guess('_female.mat_initial_alpha', 0.421, 0.001, 3, 0) %>%
  g3_init_guess('_male.mat_initial_alpha', 0.449, 0.001, 3, 0) %>%
  g3_init_guess('_female.mat_initial_a50', 14.52, 3, 25, 0) %>%
  g3_init_guess('_male.mat_initial_a50', 7.34, 3, 25, 0) %>%
  #  g3_init_guess('prop_mat0', 0.5, 0.1, 0.9, 0) %>%
  #  g3_init_guess('B0', 100, 1, 5000, 1) %>%
  g3_init_guess('mat_alpha', 70, 10, 300, 1) %>%
  g3_init_guess('_female.mat_l50',
                61.33947, 0.75*61.33947, 1.25*61.33947,
                # mat_l50$mean[1], 0.75*mat_l50$mean[1], 1.25*mat_l50$mean[1],
                1) %>%
  g3_init_guess('_male.mat_l50',
                43.62948, 0.75*43.62948, 1.25*43.62948,
                # mat_l50$mean[2], 0.75*mat_l50$mean[2], 1.25*mat_l50$mean[2],
                1) %>%
  g3_init_guess('_female.walpha',
                1.8267e-06,
                # lw_constants %>% filter(sex == "F", term == "a") %>% pull(estimate),
                1e-10, 1, 0) %>%
  g3_init_guess('_female.wbeta',
                3.4074,
                # lw_constants %>% filter(sex == "F", term == "b") %>% pull(estimate),
                2, 4, 0) %>%
  g3_init_guess('_male.walpha',
                6.1549e-06,
                # lw_constants %>% filter(sex == "M", term == "a") %>% pull(estimate),
                1e-10, 1, 0) %>%
  g3_init_guess('_male.wbeta',
                3.09421,
                # lw_constants %>% filter(sex == "M", term == "b") %>% pull(estimate),
                2, 4, 0) %>%
  g3_init_guess(
    pattern = '_female_mat\\.init\\.sd',
    value = init_sigma %>%
      filter(grepl('_female_mat', stock)) %>%
      filter(age %in%
               as.numeric(gsub("[^0-9.-]|\\.", "",
                               tmb_param[grepl('_female_mat\\.init\\.sd',
                                               tmb_param$switch),]$switch))
      ) %>%
      pull(ms),
    lower = 0, upper = 20, optimise = FALSE) %>%
  g3_init_guess(
    '_male_mat\\.init\\.sd',
    init_sigma %>%
      filter(grepl('_male_mat', stock)) %>%
      filter(
        age %in%
          as.numeric(gsub("[^0-9.-]|\\.", "",
                          tmb_param[grepl('_male_mat\\.init\\.sd',
                                          tmb_param$switch),]$switch))
      ) %>%
      pull(ms), 0, 20, 0) %>%
  g3_init_guess(
    '_female_imm\\.init\\.sd',
    init_sigma %>%
      filter(grepl('_female_imm', stock)) %>%
      filter(age %in%
               as.numeric(gsub("[^0-9.-]|\\.", "",
                               tmb_param[grepl('_female_imm\\.init\\.sd',
                                               tmb_param$switch),]$switch))
      ) %>%
      pull(ms), 0, 20, 0) %>%
  g3_init_guess(
    '_male_imm\\.init\\.sd',
    init_sigma %>%
      filter(grepl('_male_imm', stock)) %>%
      filter(age %in%
               as.numeric(gsub("[^0-9.-]|\\.", "",
                               tmb_param[grepl('_male_imm\\.init\\.sd',
                                               tmb_param$switch),]$switch))
      ) %>%
      pull(ms), 0, 20, 0) %>%
  suppressWarnings()

## Add likelihood component weights (control using set_weights argument)
if(set_weights) {
  # Copy the /iterative_reweighting/weights.final as opened in Rstudio viewer under:
  tmp_weights <- read.table(textConnection(
    '                                           comp approx_weight       weight
           cdist_sumofsquares_EggaN_matp_weight   1956.146981   188.413779
       cdist_sumofsquares_TrawlRus_ldist_weight   5453.205886   5800 # 6002.17333
          cdist_sumofsquares_EggaS_ldist_weight   5123.253902  6751.153912
           cdist_sumofsquares_EggaS_matp_weight    2359.29151   129.362033
           cdist_sumofsquares_EcoS_ldist_weight   2019.700752  1542.651765
     cdist_sumofsquares_TrawlNor_sexdist_weight    357.270496      3 # 3.84087
         cdist_sumofsquares_EcoS_sexdist_weight    767.799314    10 # 63.902305
     cdist_sumofsquares_OtherNor_sexdist_weight    266.767527     10 # 5.077274
     cdist_sumofsquares_RussianS_sexdist_weight     445.83197    4 # 16.567764
       cdist_sumofsquares_RussianS_ldist_weight   3435.084083  4000 # 4852.923418
          cdist_sumofsquares_EggaN_ldist_weight   5775.528978  9076.399318
        cdist_sumofsquares_WinterS_ldist_weight    821.343568  1774.691705
  cdist_sumofsquares_EggaN_aldist_female_weight  22009.843678 13017.349301
  cdist_sumofsquares_EggaN_aldist_male_weight     8876.3292  7223.659337
     cdist_sumofsquares_TrawlRus_sexdist_weight    383.327394     3.453648 # use 4.4 for "dome" selectivity
       cdist_sumofsquares_OtherNor_ldist_weight    7137.38441  4406.291021
       cdist_sumofsquares_TrawlNor_ldist_weight   3689.542167  6310.703921
 adist_surveyindices_log_EggaN_SI_female_weight     36.661097    200 # 28.640553
   adist_surveyindices_log_EggaN_SI_male_weight     63.890285    160 #69.810101
        adist_surveyindices_log_Juv_SI_1_weight       1.50968     20 # 4.320679
     adist_surveyindices_log_Juv_SI_2_weight      1.978355    20 # 6.441165
     adist_surveyindices_log_EcoS_SI_weight     28.296607    49.218369
     adist_surveyindices_log_RussianS_SI_weight      7.713333    30.349788
    '
  ), header = TRUE)
  
  
  param_order <- names(tmb_param[na.omit(match(tmp_weights$comp,tmb_param$switch)), "value"])
  
  tmb_param[na.omit(match(tmp_weights$comp,tmb_param$switch)), "value"] <-
    tmp_weights[na.omit(match(param_order, tmp_weights$comp)), "weight"]
  
  rm(param_order)
}

## Leave out parameters before updating with previous parameters

init_lo_param <- init_retro_param <- tmb_param

## Add the previous optimized model parameters as initial values (control using the previous_model_params_as_initial argument)

if(exists("prev_param") & previous_model_params_as_initial & !run_iterative) {
  param_order <- names(tmb_param[na.omit(match(names(prev_param),tmb_param$switch)), "value"])
  
  tmb_param[na.omit(match(names(prev_param),tmb_param$switch)), "value"] <-
    unname(prev_param[na.omit(match(param_order, names(prev_param)))])
  
  rm(param_order)
  
  # tmb_param[match(names(prev_param),tmb_param$switch), "value"] <- unname(prev_param)
}

### Force parameter bounds (experimental)

if(force_bound_params) {
  actions <- c(actions, list(g3experiments::g3l_bounds_penalty(tmb_param)))
  tmb_model <- g3_to_tmb(actions)
}

# Turn actions into an R function

model <- g3_to_r(actions)
# You can edit the model code with:
# model <- edit(model)

### Rearrange parameters to follow the model order (fixed a bug that occurs sometimes)

tmb_param <- tmb_param[match(names(attr(model,'parameter_template')), tmb_param$switch),]

## Write the parameters to a csv file

if(reset_model) {
  write.csv(tmb_param, file = file.path(base_dir, "data/Initial model parameters.csv"), row.names = FALSE)
  save(tmb_param, file = file.path(base_dir, "data/Initial model parameters.rda"))
  
  ## Save the R model
  
  save(model, file = file.path(base_dir, "data/R model.rda"), compress = "xz")
  save(tmb_model, file = file.path(base_dir, "data/TMB model.rda"), compress = "xz")
}
